/*
 * Copyright 1990 Globetrotter Software, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Globetrotter Software not be used
 * in advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  Globetrotter Software makes
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * GLOBETROTTER SOFTWARE DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO
 * EVENT SHALL GLOBETROTTER SOFTWARE BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
 * OF THIS SOFTWARE.
 *
 * Author:  Jim McBeath, Globetrotter Software
 *	    globes!jimmc@oliveb.olivetti.com
 *	    (408)741-0489
 */

/* makeform.c - builds the form which displays everything
 */

#include <X11/Intrinsic.h>
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/Core.h>
#include <X11/Shell.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <stdio.h> 
#include <ctype.h>
#include "mines.h"

extern char *MinesVersion;

void
makeform(topw,numrows,numcols,cellsize)
Widget topw;
int numrows, numcols;
int cellsize;	/* size of each cell in pixels */
{
	Widget form, cells;
	Widget top, bottom, bar;
	Widget lasthwidget, lastvwidget, w;
	Widget InitButtons(), InitMsg();
	Arg args[10];
	int i, b;
	int x,y;
	char buf[100],buf2[100],tbuf[100];
	XtTranslations tr;

	i = 0;
	form = XtCreateManagedWidget("form", formWidgetClass, topw, args, i);

	i = 0;
	XtSetArg(args[i],XtNlabel,MinesVersion);
	i++;
	lastvwidget = XtCreateManagedWidget("title",
			labelWidgetClass, form, args, i);

	InitInfoButton(topw,form,lastvwidget);

	lastvwidget = InitButtons(form,lastvwidget);
			/* init command buttons */

	lastvwidget = InitMsg(form,lastvwidget);
			/* init the message area */

	i = 0;
	XtSetArg(args[i],XtNfromVert,lastvwidget);
	i++;
	cells = XtCreateManagedWidget("cell",formWidgetClass,form,args,i);
	lastvwidget = 0;

	for (y=0; y<numrows; y++) {
		lasthwidget = (Widget)0;
		for (x=0; x<numcols; x++) {
			sprintf(buf,"R%dC%d",y,x);
			i = 0;
			XtSetArg(args[i],XtNfromVert,lastvwidget);
			i++;
			XtSetArg(args[i],XtNfromHoriz,lasthwidget);
			i++;
			XtSetArg(args[i],XtNwidth,cellsize);
			i++;
			XtSetArg(args[i],XtNheight,cellsize);
			i++;
			XtSetArg(args[i],XtNinput,TRUE);
			i++;
			w = XtCreateManagedWidget(buf,widgetClass,cells,args,i);
				/* just use a core widget */
			sprintf(tbuf,"<Expose> : DrawCell(%d %d)",
					y,x);
			tr = XtParseTranslationTable(tbuf);
			XtOverrideTranslations(w,tr);	/* add the expose tr */
			lasthwidget = w;
			SetCellWidget(y,x,w);
		}
		lastvwidget = w;
	}
}

/* end */
