/*
 * Copyright (c) 1987 Tom Anderson; 20831 Frank Waters Road;
 * Stanwood, WA  98282.
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Tom Anderson not be used
 * in advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  Tom Anderson makes
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * TOM ANDERSON DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO
 * EVENT SHALL TOM ANDERSON BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
 * OF THIS SOFTWARE.
 *
 */

/* #define TINY_GAME	/* for debugging */

/*
 * mines header
 *
 */

#define BOOL 			int
#ifndef TRUE
#define TRUE			1
#endif
#ifndef FALSE
#define FALSE			0
#endif

/*
 * number of board squares per side 
 */
#define	MAX_BOARD_ROWS		100
#define MAX_BOARD_COLS		100
#define DEFAULT_BOARD_ROWS	12
#define DEFAULT_BOARD_COLS	12

/*
 * board coordinates
 */
typedef struct {
    int x;
    int y;
} BoardCoordinate;

/*
 * square state
 */
typedef struct {
    BOOL traversed;		/* has the poor soul stepped here?	*/
    BOOL mined;			/* is this square mined?		*/
    BOOL occupied;		/* is this square occupied?		*/
    BOOL unsafe;		/* has the player determined a mine here?*/
    BOOL safe;			/* has the player determined no mines here?*/
    BOOL visited;		/* has connected test looked here yet?	*/
    int nearby;			/* number of mines nearby.		*/
    short row,col;
    Widget w;
} Square;

/* end */
