.TH XMINES 1 "22 August 1990" "X Version 11 Release 4"
.SH NAME
xmines - a minefield game
.SH SYNOPSIS
\fBxmines\fP [ \fI-toolkitoption\fP ...]
[-cellsize \fIcellsize\fP]
[-rows \fIrows\fP]
[-columns \fIcolumns\fP]
[-mines \fImines\fP]
.SH DESCRIPTION
The \fIxmines\fP program is a game in which you attempt to cross
a minefield without getting blown up.
You can control the size of the minefield and the density of the mines.
At each step, you are told how many mines are in the neighboring locations,
from which you can often deduce the locations of the mines.
If you are stuck, you have the option of asking for a hint if you don't
feel like taking a chance on moving to a location which might contain a mine.
Xmines keeps track of how many moves and hints you have used, and how many
safe and mined locations you have marked.
.SH OPTIONS
.I Xmines
accepts all of the standard X Toolkit command line options.
In addition, the command line options listed below may be specified.
Each of these command line options corresponds to a resource.
For more information about the effect of these command line options,
see the RESOURCES section below.
.PP
The command line options and the resources they represent are:
.TP 8
.B \-cellsize \fIsize\fP
This option specifies the size in pixels of each of the cells (squares)
in the playing field.
The cellsize command line option corresponds to the "cellSize" resource.
.TP 8
.B \-rows \fInumber\fP
This option specifies the number of rows in the playing field.
The rows command line option corresponds to the "rows" resource.
.TP 8
.B \-columns \fInumber\fP
This option specifies the number of columns in the playing field.
The columns command line option corresponds to the "columns" resource.
.TP 8
.B \-mines \fInumber\fP
This option specifies the number of mines to be placed in the playing field.
The mines command line option corresponds to the "mines" resource.
.SH "THE DISPLAY"
.PP
The \fIxmines\fP window contains the following:
a title line, a command widget line,
a count display line, a status line, and the playing field.
.PP
The title line lists the class name (XMines) and the current version
of xmines.
.PP
The command widget line contains a number of input widgets that you use
to control the program.  These are:
.IP "Mine count" 8
This text field allows you to enter a new mine count.
This allows you to play an easier or harder game.
When you enter a return in this field, a restart is automatically done.
Note that you must delete the old number before putting in a new number.
If you enter a number that is too large, \fIxmines\fP will limit it to
the largest number of mines that will fit into the board;
however, this will always produce a minefield which is impossible to
traverse (see the discussion under the "restart" button below).
This is a standard text widget, so you can cut and paste or define
editing translations to your own desires using the standard text
widget actions.
.IP restart 8
When this button is pressed, \fIxmines\fP resets the playing field.
The number of mines specified in the "Mine count" widget are hidden in the
playing field, and the player is placed into the upper left square.
The object of the game is to move the player to the goal square in the
lower right corner of the playing field.
\fIXmines\fP will never place a mine in the starting square, the goal
square, or the three squares immediately adjacent to the starting square.
Thus, when you first start a game, you will always see the message
"No mines nearby" in the status line.
If the number of mines is very large, it is possible to generate a
minefield which has no safe path from start to goal.
In this case, the word "(impossible)" appears in the status line.
You can either select a smaller number of mines and try again, or
simply try again with the same number until a potentially traversable
minefield is generated.
.IP hint 8
If you are stuck and want to know which neighboring square you can move
to that is guaranteed not to contain a mine, you can press this button,
and \fIxmines\fP will mark one of the adjacent squares as "ok", meaning
there is no mine there.
If one of the adjacent squares is already marked as "ok" but not yet
traversed, or if there are no adjacent and untraversed squares which
do not contain mines, then no square is marked.
The number of hints you have asked for is displayed in the line below
the buttons.
.IP quit 8
When this button is pressed, \fIxmines\fP exits.
.PP
The count display line displays the various numbers that the program
keeps track of:
.IP Moves 8
The number of moves that you have made so far in this round.
.IP Hints 8
The number of hints that you have asked for so far in this round.
This number is incremented even if you ask for a hint and no squares
are marked "ok".
.IP Safes 8
The number of squares which are marked "ok".
Each time you mark a square as safe, this number increments.
Each time you unmark a safe square, either
by explicitly unmarking it, marking it as a mine, or moving onto it,
this number is decremented.
.IP Mines
The number of squares which are marked as mines.
Each time you mark a square as mined, this number increments.
Each time you unmark a mined square, either
by explicitly unmarking it, marking it as safe,
this number is decremented.
.PP
The status line displays messages concerning the progress of the game.
On a normal move, it tells you how many mines are in the adjacent squares.
If you reach the goal, or step on a mine, it displays an appropriate message.
.PP
The playing field is an array of cells (locations, squares), each of
which can potentially contain a mine.
One of the squares contains a stick man which represents your current
location in the minefield.
Squares which you have already been traversed show the number of mines which
are adjacent to that square.
The number in the same square as the stick man shows the number of mines
adjacent to that position.
You use the pointer buttons to move your man around the minefield or to
mark squares as safe or mined (see the section "ACTIONS" below).
.SH X RESOURCES
\fIXmines\fP accepts all of the standard X Toolkit resource names and classes
as well as:
.TP 8
.B "cellSize (\fPclass\fB CellSize)"
This resource specifies the size, in pixels, of each cell in the playing
field.
Since the pictures which are placed into the cells are pixmaps, cell sizes
which do not match the pixmap sizes lead to white space (if cell size is
larger than pixmap size), or a cropped picture (if cell size is smaller than
pixmap size).
There are two sizes of pixmap available, 16 and 32.
\fIXmines\fP will use the 16 bit pixmaps if the cell size is 31 or less,
and will use the 32 bit pixmaps if the cell size is 32 or greater.
.TP 8
.B "rows (\fPclass\fB ArraySize)"
This resource specifies the number of the rows in the playing field.
This is typically the same number as the columns resources.
.TP 8
.B "columns (\fPclass\fB ArraySize)"
This resource specifies the number of the columns in the playing field.
This is typically the same number as the rows resources.
.TP 8
.B "mines (\fPclass\fB Mines)"
This resource specifies the number of mines to place into the playing field.
.SH WIDGET NAMES
This section describes the widget tree used in \fIxmines\fP.
By using these names in your resource specifications, you can configure
things like colors and sizes for the various widgets.
.PP
The program name is taken from the command line, and the class name is XMines.
.PP
The chart below gives the widget name followed by the name of its class in
parentheses.
All of the widgets are from the Athena Widget set.
.PP
.nf
.na
xmines(Shell - top level toolkit widget)
	form(Form)
		title(Label)
		info(Command)
		countlabel(Label)
		mineinputcount(AsciiText)
		restart(Command)
		hint(Command)
		quit(Command)
		movelabel(Label)
		movecount(Label)
		hintlabel(Label)
		hintcount(Label)
		safelabel(Label)
		safecount(Label)
		minelabel(Label)
		minecount(Label)
		message(Label)
		cell(Form)
			R%dC%d(Widget) *
xmines_info(ApplicationShell)
	info(Form)
		version(Label)
		text(Command)
.fi
.ad
.PP
* The widgets labeled R%dC%d are the array of cells.  The %d fields are
filled in with the row and column number of that cell, starting at 0.
Thus the cell in the top left corner of the array is R0C0, the cell to
its right is R0C1, etc.
These widgets are Core widgets, so they have only the basic resources.
.SH ACTIONS
.PP
XMines defines four actions that can be invoked through translations.
These actions are:
.IP "DrawCell(row,col)" 8
Refreshes the specified cell.
This action is invoked by each cell in response to an expose event in
order to refresh itself.
If DrawCell is invoked with no parameters, it will refresh the current cell.
.IP "MovePlayer()" 8
Moves the player to the cell from which the action was invoked.
This is normally bound to the left mouse button to allow you to move
around the playing field.
If you move onto a mine, the game ends.
You can not move to a cell which is marked as mined.
You can move directly to any square which has been previously traversed,
or to any square immediately adjacent to one which has been previously
traversed (except those marked as mined).
.IP "MarkMined()" 8
Marks the cell as a mined cell.
This is normally bound to the center mouse button.
If the cell is already marked as mined, it will be unmarked.
If the cell is marked as safe, it will be marked as mined.
The safe and mined count fields are updated.
.IP "MarkSafe()" 8
Marks the cell as a safe cell.
This is normally bound to the right mouse button.
If the cell is already marked as safe, it will be unmarked.
If the cell is marked as mined, it will be marked as safe.
The safe and mined count fields are updated.
.SH COPYRIGHT
Copyright 1987, Tom Anderson
.br
Copyright 1990, Globetrotter Software, Inc.
.br
See \fIX(1)\fP for a full statement of rights and permissions.
.SH AUTHORS
Tom Anderson, Fluke Manufacturing Co. Inc.
.br
Brian Dalio, Mentor Graphics, Silicon Design Division.
.br
Jim McBeath, Globetrotter Software, Inc.
